Subject: Re: bug#62679: 29.0.60; Bindings on `image-map` cause error on sliced images

From: Rah Guzar <[email-masked]>
Date: Thu, 06 Apr 2023 20:30:19 +0200

Eli Zaretskii <[email-masked]> writes:

>> From: Rah Guzar <[email-masked]>
>> Cc: Lars Ingebrigtsen <[email-masked]>, [email-masked]
>> Date: Thu, 06 Apr 2023 17:43:55 +0200
>>
>> Hi Eli,
>>   I can confirm that the issue is mostly fixed now. One thing I noticed
>>   was that it is still possible to trigger the error by starting with my
>>   recipe before, moving the point to somewhere on the image and then
>>   using right arrow key. Since the image has a single column the point
>>   is now off image but on the same line. This buffer position still has
>>   the "image-map" and pressing e.g. "i +" still causes the error.
>
> I cannot reproduce this.  On my system, if I move point with the right
> arrow key, "M-x describe-text-properties" doesn't show the keymap
> property.
>

You are right there is no keymap property there but somehow "image-map"
is still active. I can press "i +" there and see the error while after or
before the image pressing "i +" will insert the two characters.

>>   According to the info manual, the advantage of using sliced images is
>>   to get a more intuitive scrolling behavior and that is the reason I am
>>   using them. I think for everything else the image should behave as a
>>   single image. For that reason the behavior of "i r" seems correct to
>>   me. It rotates the image and then slices.
>
> If this is what you see, I guess you have Emacs built with
> ImageMagick?  I don't see "rotation followed by slicing", because the
> code doesn't do that, at least not with rotation that is implemented
> natively in Emacs on my system.  But, as I said, rotation of sliced
> image is not well defined, so my opinion is that people should not
> depend on it doing something sensible.

Evaluating "(image-type-available-p 'imagemagick)" returns nil so I
think Emacs is built without imagemagick support. The sequence of
command I ran to build it were
./configure --with-pgtk
make
make bootstrap
where the first make failed due to some org issue.

But to the broader point about rotation not being sensible I think it
might be a good idea to put a different keymap on sliced images in that
case. Maybe "sliced-image-map" which should be the parent of
"image-map". I don't see any misbehavior though.